'  ===========================================================================
'
'  BR404
'  the VSTi synthesizer for Windows systems
'
'  Finally available for your home computer:
'  The brandnew *farbrausch* software synthesizer VSTi  programmed by Benjamin BeRo Rosseaux.
'  Features
'
'      * many different oscillator waveforms and filters
'      * ADSR and freeform envelopes
'      * extensive modulation matrix
'      * sample exact modulations
'        (the main reason why BR404 may use slightly more CPU time than other comparable synths)
'      * sample support
'      * speech synthesizer
'      * PADsynth algorithm
'      * custom LFO waveforms per sample
'      * 10-band equalizer, Winamp compatible parameter presets
'      * multiple instances
'      * export song as win32 executable
'      * own fileformat (bmf2wav converter included)
'      * replay plugin for Winamp (and compatibles)
'      * SDK for Delphi 5/7, FreePascal 2.x and MSVC / MSVC COFF library file format compatible products included
'      *  and a whole lotta more for you to discover!
'
'      http://www.farbrausch.de/br404/
'
'  ===========================================================================
'
'  ===========================================================================
'   Freebasic compatible library and wrapper by rbz - 01 Feb 2009
'  ===========================================================================


#include "windows.bi"
#include "libbr404.bi"

'Include song
#include "tune.bas" 

    Cls
    Locate 1, 1
 
    Print "-------------------------------------------------------------"
    Print "Farbrausch BR404 Tiny Music Player"
    Print "BR404 Code Copyright (C) 2004-2008 BeRo^Farbrausch"
    Print ""
    Print "Freebasic compatible library and wrapper by rbz - 01 Feb 2009"
    Print "-------------------------------------------------------------"

    dim Track as any ptr
    Track = SynthCreate( SynthReadBMFSampleRate(@TrackData(0),TrackSize) ,2048,1,1)
    
    SynthReadBMF(Track,@TrackData(0),TrackSize)
    
    SynthPlay(Track)

    Print "-------------------------------------------------------------"
    Print "Playing song ..."
    Print "Press a key to exit"

    dim anim(4) as string
    anim(0) = "|"
    anim(1) = "/"
    anim(2) = "-"
    anim(3) = "\"
  
    While Inkey$ = ""
        
 		' draw rotating stuff and make sure we don't use up 100% cpu
		locate 10,1
		print anim((GetTickCount()/250.0) and 3)
		Sleep(10) 
      
    Wend
   
	' stop and deinit the player
    SynthEnter(Track)
    SynthStop(Track)
    SynthLeave(Track)
    SynthDestroy(Track)

    Print "Music Stopped"
    Sleep 2000
    
	' ... and we're done.
	ExitProcess(0)
    
    End
    
    

 